/*
 * Utility functions for base types.
 *
 * Copyright (C) 2022, 2023 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/re/c/dataspace.h>

#include "base.h"



/* Return mapping flags corresponding to page fault flags. */

map_flags_t map_flags_for_fault(l4_umword_t flags)
{
  map_flags_t map_flags = (flags & 4 ? L4RE_DS_F_RX : 0) |
                          (flags & 2 ? L4RE_DS_F_W : 0) |
                          (flags & 1 ? L4RE_DS_F_R : 0);

  if (!map_flags)
    map_flags = L4RE_DS_F_R;

  return map_flags;
}

// vim: tabstop=2 expandtab shiftwidth=2
